/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

/*
 * 
 * Authors: Silvano Squizzato <silvano.squizzato@pd.infn.it>
 * 
 */

package org.glite.ce.cream.cmdmanagement.db;

import java.util.ArrayList;
import java.util.List;

import org.glite.ce.creamapi.cmdmanagement.Command;

/**
 * Class collecting utility methods to test command management.
 *
 */
public class CommandTestUtil {
    
    /**
     * Returns a dummy Command.
     * @param userId The userId to set.
     * @return a dummy Command.
     */
    public static Command getCommand(String userId) {
        Command cmd = new Command("Test Command");
        cmd.setUserId(userId);
        CommandParameter p1 = new CommandParameter("ParameterName1", "Value1");
        CommandParameter p2 = new CommandParameter("ParameterName2", "Value2");
        cmd.addParameter(p1.getName(), p1.getValue());
        cmd.addParameter(p2.getName(), p2.getValue());
        List<String> parameterValues = new ArrayList<String>();
        parameterValues.add("MValue_1");
        parameterValues.add("MValue_2");
        cmd.addParameter("MVParameter", parameterValues);
        return cmd;
    }
}
