/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

/*
 * 
 * Authors: Silvano Squizzato <silvano.squizzato@pd.infn.it>
 * 
 */

package org.glite.ce.cream.cmdmanagement.queue.db;

import java.util.Iterator;
import java.util.List;

import org.glite.ce.common.db.DatabaseException;
import org.glite.ce.creamapi.cmdmanagement.CommandException;
import org.glite.ce.creamapi.cmdmanagement.queue.CommandQueueException;


/**
 * Class to test command in the dB command queue.
 */
public final class CommandQueueListTest {
   
	public static void main(String[] args) throws Exception {
	    test1(); 
	}
	
    /**
     * Tests operations in a command queue list.
     * - list
     * - insert
     * - delete
     * - list
     * @throws DatabaseException
     * @throws IllegalArgumentException
     * @throws CommandQueueException 
     * @throws CommandException 
     */
    private static void test1() throws DatabaseException, IllegalArgumentException, CommandQueueException, CommandException {
        CommandQueueDBManager manager = new CommandQueueDBManager("JOB_MANAGEMENT");
          
        List<String> names = manager.findQueueNames();
      
        System.out.println("Executed findQueueNames");
        for (Iterator<String> iterator = names.iterator(); iterator.hasNext();) {
            String name = iterator.next();
            System.out.println("Queue name = " + name);
            
        }
        String q = "Q2";
        manager.insertQueue(q);
        
        names = manager.findQueueNames();
        
        System.out.println("Executed findQueueNames");
        for (Iterator<String> iterator = names.iterator(); iterator.hasNext();) {
            String name = iterator.next();
            manager.deleteQueue(name);
            System.out.println("deleted queue name = " + name);
        }
        System.out.println("End");

    }
}
