/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

package org.glite.ce.cream.cmdmanagement.queue.db;

import org.glite.ce.cream.cmdmanagement.db.CommandDBManager;
import org.glite.ce.creamapi.cmdmanagement.Command;
import org.glite.ce.creamapi.cmdmanagement.CommandException;
import org.glite.ce.creamapi.cmdmanagement.queue.CommandQueueException;

public class Enqueuer implements Runnable {
    
    private CommandQueueDBManager queueManager = null;
    private CommandDBManager cmdManager = null;

    public void run() {
        try {
            for (int i = 0; i < 50; i++) {
                Command cmd = getCommand("userY");
                cmdManager.insertCommand(cmd);
                queueManager.enqueueCommand(cmd);
                
            }
        } catch (IllegalArgumentException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (CommandQueueException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (CommandException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    /**
     * Returns a dummy Command.
     * @param userId The userId to set.
     * @return a dummy Command.
     */
    public static Command getCommand(String userId) {
        Command cmd = new Command("Test Command");
        cmd.setUserId(userId);
        return cmd;
    }

    public Enqueuer(CommandDBManager cmdManager, CommandQueueDBManager queueManager) {
        super();
        this.cmdManager = cmdManager;
        this.queueManager = queueManager;
    }
}
