/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

package org.glite.ce.cream.cmdmanagement.queue.db;

import org.glite.ce.creamapi.cmdmanagement.Command;
import org.glite.ce.creamapi.cmdmanagement.queue.CommandQueueException;

public class Fetcher implements Runnable {
    
    private CommandQueueDBManager queueManager = null;
    
    private int times = 0;

    public void run() {
        try {
            Command fetchedCmd = null;
            while (true) {
                fetchedCmd = queueManager.fetchCommand();
                if (fetchedCmd != null) {
                    System.out.println("Fetched command with cmdId = " + fetchedCmd.getId() + "_" + Thread.currentThread().getName() +  ", iteration times=" + times);
                } else {
                    System.out.println("Fetched command is null");
                }
                times++;
            }
        } catch (IllegalArgumentException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (CommandQueueException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    public Fetcher(CommandQueueDBManager queueManager) {
        super();
        this.queueManager = queueManager;
    }
}
