/*
 * Copyright (c) Members of the EGEE Collaboration. 2004. 
 * See http://www.eu-egee.org/partners/ for details on the copyright
 * holders.  
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 *
 *     http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 */

/*
 *
 * Authors: Eric Frizziero <eric.frizziero@pd.infn.it>
 * 
 */

package org.glite.ce.cream.jobmanagement.db;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Hashtable;

import org.glite.ce.common.db.DatabaseException;
import org.glite.ce.common.db.DatasourceManager;
import org.glite.ce.cream.jobmanagement.db.table.EnviromentTable;
import org.glite.ce.creamapi.jobmanagement.db.table.EnviromentTableInterface;


public class EnviromentTableTest {
	String datasourceName = null;
	EnviromentTableInterface   jobEnviromentTable   = null;
	
	public EnviromentTableTest()throws Exception{
	  this.jobEnviromentTable   = new EnviromentTable();
	}
	
	public int executeInsertTest(String jobId) throws DatabaseException{
		Hashtable<String, String> enviroment = new Hashtable<String, String>();
		int rowInserted = -1;
		enviroment.put("key1", "value1");
		enviroment.put("key2", "value2");
		enviroment.put("key3", "value3");
		 Connection connection = null;
		  try{
			  connection = DatasourceManager.getConnection(this.datasourceName);
		      rowInserted = jobEnviromentTable.executeInsert(jobId, enviroment, connection);
		      connection.commit();
		      System.out.println("rowInserted = " + rowInserted);
		  }catch (SQLException sqle){
			  System.out.println("Exception: " + sqle.getMessage());
		  }finally {
			   if (connection != null) {
			       try {
			           connection.close();
			       } catch (SQLException sqle) {
			           //do nothing
			       }
			   } 
		  } 
		return rowInserted;
	}

	 public int executeDeleteTest(String jobId) throws DatabaseException{
		 Connection connection = null;
		 int rowDeleted = -1;
		  try{
			  connection = DatasourceManager.getConnection(this.datasourceName);
		      rowDeleted = jobEnviromentTable.executeDelete(jobId, connection);
		      connection.commit();
		  }catch (SQLException sqle){
			  System.out.println("Exception: " + sqle.getMessage());
		  }finally {
			   if (connection != null) {
			       try {
			           connection.close();
			       } catch (SQLException sqle) {
			           //do nothing
			       }
			   } 
		  }    
		  return rowDeleted; 
	 }
	 
	  public static void main(String[] args) throws Exception{
		  EnviromentTableTest enviromentTableTest = new EnviromentTableTest();
		  
		  String jobId = "CREAM506445737";
		  //TEST INSERT
		  int rowInserted = enviromentTableTest.executeInsertTest(jobId);
		  System.out.println("rowInserted must be 3 ... = " + rowInserted);
		  //TEST delete
		  int rowDeleted = enviromentTableTest.executeDeleteTest(jobId);
		  System.out.println("rowDeleted must be 3 ... = " + rowDeleted);
	  }
}
